import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Flys try to avoid being eaten by the frogs
 * 
 * @author: J Woodard
 * @version: 1.0
 */
public class Fly extends Animal
{
   
    
    /**
     * Act - do whatever the Fly wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        //turn if at the world edge
        if ( atWorldEdge() )
        {
            turn(17);
        }
        
        myRandomTurn();
        move(5);
        checkKeyBoardSelection();
    }
    
    /**
     * test that we are not at the edge of our world, if so, then turn
     */
    public boolean atWorldEdge()
    {
        World w = getWorld();
        if ( getX() < 20 || getX() > w.getWidth() - 20 )
        {
            return true;
        }
        if ( getY() < 20 || getY() > w.getHeight() - 20 )
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    /**
     * Allow the fly to make random turns in both the positive and negative
     * direction 10 percent of the time.
     */
    public void myRandomTurn()
    {
        if ( Greenfoot.getRandomNumber(100) < 10 )
        {
            turn(Greenfoot.getRandomNumber(91)-45);
        }
    }
    
    /**
     * React accordingly if a keyboard control key has been selected. 
     */
    public void checkKeyBoardSelection()
    {
        if (Greenfoot.isKeyDown("left") )
        {
            turn(-4);
        }
        if (Greenfoot.isKeyDown("right") )
        {
            turn(4);
        }
    }
    
    
}

